# Compiling and Installing

1. Unix / X11
   - General prerequisites for building
   - Prerequisites for DRI and hardware acceleration
   - Building with autoconf
   - Building with traditional Makefiles
   - The Libraries
   - Installing the header and library files
   - Building OpenGL programs with pkg-config
2. Windows
3. Building with SCons
4. Other

## 1. Unix/X11 Compilation and Installation

### 1.1 General prerequisites for building

- lex / yacc - for building the GLSL compiler. On Linux systems, flex and bison are used. Versions 2.5.35 and 2.4.1, respectively, (or later) should work.
- python - Python is needed for building the Gallium components. Version 2.6.4 or later should work.

### 1.2 Prerequisites for DRI and hardware acceleration

The following are required for DRI-based hardware acceleration with Mesa:

- dri2proto version 1.99.3 or later
- Linux 2.6.28
- libDRM version 2.4.15 or later
- Xorg server version 1.5 or later

### 1.3 Building with Autoconf

Mesa may be built using autoconf. This should work well on most GNU-based systems. If that fails the traditional Mesa build system is available.

### 1.4 Building with traditional Makefiles

The traditional Mesa build system is based on a collection of pre-defined system configurations.

To see the list of configurations, just type `make`. Then choose a configuration from the list and type `make` configname.

Mesa may be built in several different ways using the predefined configurations:

- Stand-alone/Xlib mode - Mesa will be compiled as a software renderer using Xlib to do all rendering. The libGL.so library will be a self-contained rendering library that will allow you to run OpenGL/GLX applications on any X server (regardless of whether it supports the GLX X server extension). You will not be able to use hardware 3D acceleration.

  To compile stand-alone Mesa type `make` in the top-level directory. You'll see a list of supported system configurations. Choose one from the list (such as linux-x86), and type:

          make linux-x86

  This will produce libGL.so and several other libraries

- DRI/accelerated - The DRI hardware drivers for accelerated OpenGL rendering (for ATI, Intel, Matrox, etc) will be built. The libGL.so library will support the GLX extension and will load/use the DRI hardware drivers.

  Build Mesa and the DRI hardware drivers by running

         make linux-dri

  There are also `linux-dri-x86`, `linux-dri-x86-64`, and `linux-ppc` configurations which are optimized for those architectures.

  Make sure you have the prerequisite versions of DRM and Xserver mentioned above.

Later, if you want to rebuild for a different configuration run `make realclean` before rebuilding.

### 1.5 The libraries

When compilation has finished, look in the top-level `lib/` (or `lib64/`) directory. You'll see a set of library files similar to this:

    lrwxrwxrwx    1 brian    users          10 Mar 26 07:53 libGL.so -> libGL.so.1*
    lrwxrwxrwx    1 brian    users          19 Mar 26 07:53 libGL.so.1 -> libGL.so.1.5.060100*
    -rwxr-xr-x    1 brian    users     3375861 Mar 26 07:53 libGL.so.1.5.060100*
    lrwxrwxrwx    1 brian    users          11 Mar 26 07:53 libGLU.so -> libGLU.so.1*
    lrwxrwxrwx    1 brian    users          20 Mar 26 07:53 libGLU.so.1 -> libGLU.so.1.3.060100*
    -rwxr-xr-x    1 brian    users      549269 Mar 26 07:53 libGLU.so.1.3.060100*
    lrwxrwxrwx    1 brian    users          12 Mar 26 07:53 libglut.so -> libglut.so.3*
    lrwxrwxrwx    1 brian    users          16 Mar 26 07:53 libglut.so.3 -> libglut.so.3.7.1*
    -rwxr-xr-x    1 brian    users      597754 Mar 26 07:53 libglut.so.3.7.1*
    lrwxrwxrwx    1 brian    users          14 Mar 26 07:53 libOSMesa.so -> libOSMesa.so.6*
    lrwxrwxrwx    1 brian    users          23 Mar 26 07:53 libOSMesa.so.6 -> libOSMesa.so.6.1.060100*
    -rwxr-xr-x    1 brian    users       23871 Mar 26 07:53 libOSMesa.so.6.1.060100*

libGL is the main OpenGL library (i.e. Mesa).
libGLU is the OpenGL Utility library.
libglut is the GLUT library.
libOSMesa is the OSMesa (Off-Screen) interface library.

If you built the DRI hardware drivers, you'll also see the DRI drivers:

    -rwxr-xr-x   1 brian users 16895413 Jul 21 12:11 i915_dri.so
    -rwxr-xr-x   1 brian users 11849858 Jul 21 12:12 r200_dri.so
    -rwxr-xr-x   1 brian users 16050488 Jul 21 12:11 r300_dri.so
    -rwxr-xr-x   1 brian users 11757388 Jul 21 12:12 radeon_dri.so

If you built with Gallium support, look in lib/gallium/ for Gallium-based versions of libGL and device drivers.

### 1.6 Installing the header and library files

The standard location for the OpenGL header files on Unix-type systems is in `/usr/include/GL/`. The standard location for the libraries is `/usr/lib/`. For more information see, the Linux/OpenGL ABI specification.

If you'd like Mesa to co-exist with another implementation of OpenGL that's already installed, you'll have to choose different directories, like `/usr/local/include/GL/` and `/usr/local/lib/`.

To install Mesa's headers and libraries, run `make install`. But first, check the Mesa/configs/default file and examine the values of the INSTALL_DIR and DRI_DRIVER_INSTALL_DIR variables. Change them if needed, then run `make install`.

The variable DESTDIR may also be used to install the contents to a temporary staging directory. This can be useful for package management. For example: `make install DESTDIR=/somepath/`

Note: at runtime you can use the LD_LIBRARY_PATH environment variable (on Linux at least) to switch between the Mesa libraries and other vendor's libraries whenever you want. This is a handy way to compare multiple OpenGL implementations.

### 1.7 Building OpenGL programs with pkg-config

Running `make install` will install package configuration files for the pkg-config utility.

When compiling your OpenGL application you can use pkg-config to determine the proper compiler and linker flags.

For example, compiling and linking a GLUT application can be done with:

       gcc `pkg-config --cflags --libs glut` mydemo.c -o mydemo

## 2. Windows Compilation and Installation

Please see the instructions on building with SCons.

## 3. Building with SCons

To build Mesa with SCons on Linux or Windows do

        scons

The build output will be placed in build/platform-machine-debug/..., where platform is for example linux or windows, machine is x86 or x86_64, optionally followed by -debug for debug builds.

To build Mesa with SCons for Windows on Linux using the MinGW crosscompiler toolchain do

        scons platform=windows toolchain=crossmingw machine=x86 mesagdi libgl-gdi

This will create:

- build/windows-x86-debug/mesa/drivers/windows/gdi/opengl32.dll — Mesa + swrast, binary compatible with Windows's opengl32.dll
- build/windows-x86-debug/gallium/targets/libgl-gdi/opengl32.dll — Mesa + Gallium + softpipe, binary compatible with Windows's opengl32.dll

Put them all in the same directory to test them.

## 4. Other systems

Documentation for other environments (some may be very out of date):

- README.VMS - VMS
- README.CYGWIN - Cygwin
- README.WIN32 - Win32